﻿#property copyright "Copyright 2010,  SSN  "
#property link      "STEVENNJUKI@GMAIL.COM"
#property version   "26th NOV 2010"

   class CRatesArray{
      public:
                           CRatesArray();
                           ~CRatesArray();
      virtual double       AskOpen(string symbol,int index,ENUM_TIMEFRAMES timeframe);
      virtual double       AskHigh(string symbol,int index,ENUM_TIMEFRAMES timeframe);
      virtual double       BidOpen(string symbol,int index,ENUM_TIMEFRAMES timeframe);
      virtual double       BidHigh(string symbol,int index,ENUM_TIMEFRAMES timeframe);
      virtual double       AskHighest(string symbol,int index,int delta,ENUM_TIMEFRAMES timeframe);
      virtual double       BidHighest(string symbol,int index,int delta,ENUM_TIMEFRAMES timeframe);
      virtual double       AskLowest(string symbol,int index,int delta,ENUM_TIMEFRAMES timeframe);
      virtual double       BidLowest(string symbol,int index,int delta,ENUM_TIMEFRAMES timeframe);
      virtual double       BidLow(string symbol,int index,ENUM_TIMEFRAMES timeframe);
      virtual double       BidClose(string symbol,int index,ENUM_TIMEFRAMES timeframe);
      virtual double       AskLow(string symbol,int index,ENUM_TIMEFRAMES timeframe);
      virtual double       AskClose(string symbol,int index,ENUM_TIMEFRAMES timeframe);
      protected:
      void                 Refresh(string symbol,int index,int delta,ENUM_TIMEFRAMES timeframe);
      double               SetPoint(string symbol,ENUM_TIMEFRAMES timeframe);
      MqlRates             RATES[];
      int                  i,j,tries,trylimit,trywait;};
   
   void CRatesArray::CRatesArray(){
      trylimit=10;
      trywait=1000;}
   
   double CRatesArray::AskOpen(string symbol,int index,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,0,timeframe);
      return(RATES[index].open+SetPoint(symbol,timeframe)*RATES[index].spread);}
   
   double CRatesArray::BidOpen(string symbol,int index,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,0,timeframe);
      return(RATES[index].open);}
      
   double CRatesArray::AskHighest(string symbol,int index,int delta,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,delta,timeframe);
      double askmax[];
      ArrayFree(askmax);
      ArrayResize(askmax,delta);
      for(i=index;i<index+delta;i++){
         for(j=0;j<ArraySize(askmax);j++){
            askmax[j]=RATES[i].high+SetPoint(symbol,timeframe)*RATES[i].spread;}}
      return(askmax[ArrayMaximum(askmax)]);}
      
   double CRatesArray::BidHighest(string symbol,int index,int delta,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,delta,timeframe);
      double bidmax[];
      ArrayFree(bidmax);
      ArrayResize(bidmax,delta);
      for(i=index;i<index+delta;i++){
         for(j=0;j<ArraySize(bidmax);j++){
            bidmax[j]=RATES[i].high;}}
      return(bidmax[ArrayMaximum(bidmax)]);}
   
   double CRatesArray::BidHigh(string symbol,int index,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,0,timeframe);
      return(RATES[index].high);}
   
   double CRatesArray::AskHigh(string symbol,int index,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,0,timeframe);
      return(RATES[index].high+SetPoint(symbol,timeframe)*RATES[index].spread);}
   
   double CRatesArray::AskLow(string symbol,int index,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,0,timeframe);
      return(RATES[index].low+SetPoint(symbol,timeframe)*RATES[index].spread);}
   
   double CRatesArray::BidLow(string symbol,int index,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,0,timeframe);
      return(RATES[index].low);}
      
   double CRatesArray::AskLowest(string symbol,int index,int delta,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,delta,timeframe);
      double askmin[];
      ArrayFree(askmin);  
      ArrayResize(askmin,delta);
      for(i=index;i<index+delta;i++){
         for(j=0;j<ArraySize(askmin);j++){
            askmin[j]=RATES[i].low+SetPoint(symbol,timeframe)*RATES[i].spread;}}
      return(askmin[ArrayMinimum(askmin)]);}
   
   double CRatesArray::BidLowest(string symbol,int index,int delta,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,delta,timeframe);
      double bidmin[];
      ArrayFree(bidmin);  
      ArrayResize(bidmin,delta); 
      for(i=index;i<index+ArraySize(bidmin);i++){
         for(j=0;j<ArraySize(bidmin);j++){
            bidmin[j]=RATES[i].low;}}
      return(bidmin[ArrayMinimum(bidmin)]);}
      
   double CRatesArray::BidClose(string symbol,int index,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,0,timeframe);
      return(RATES[index].close);}
   
   double CRatesArray::AskClose(string symbol,int index,ENUM_TIMEFRAMES timeframe){
      Refresh(symbol,index,0,timeframe);
      return(RATES[index].close+SetPoint(symbol,timeframe)*RATES[index].spread);}
      
   void CRatesArray::Refresh(string symbol,int index,int delta,ENUM_TIMEFRAMES timeframe){
      ArrayFree(RATES);  
      ArrayResize(RATES,index+delta+1);
      int tries=0;
      while(CopyRates(symbol,Period(),0,ArraySize(RATES),RATES)<ArraySize(RATES) && ++tries<trylimit){Sleep(trywait);}}
   
   double CRatesArray::SetPoint(string symbol,ENUM_TIMEFRAMES timeframe){
      int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
      double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
      if(digits==5||digits==3){point*=10;}
      return(point);}
    
   void CRatesArray::~CRatesArray(){}       